@use "sass:math";
$rem-baseline: 16px;
$rem-px-only: false !default;
// * HOW TO USE IT *
//Start of box Examples
/*
    *   .default{
    *        font-size: rem(24px); // Simple
    *        padding: rem(5px 10px); // Multiple values
    *        border-bottom: rem(1px solid black); // Multiple mixed values
    *        box-shadow: rem(0 0 2px #ccc, inset 0 0 5px #eee); // Comma-separated values
    *    }
    *   mixin version
    *   @include rem($properties, $values...)
    *   // Example
    *   @include rem(margin,15px 5px 12px 0)
    *   @include rem(padding-top,4px)
*/


@function rem-separator($list, $separator: false) {
    @if $separator=="comma"or $separator=="space" {
        @return append($list, null, $separator);
    }

    @if function-exists("list-separator")==true {
        @return list-separator($list);
    }

    $test-list: ();

    @each $item in $list {
        $test-list: append($test-list, $item, space);
    }

    @return if($test-list==$list, space, comma);
}

@function rem-convert($to, $values...) {
    $result: ();
    $separator: rem-separator($values);

    @each $value in $values {
        @if type-of($value)=="number"and unit($value)=="rem"and $to=="px" {
            $result: append($result, math.div($value, 1rem) * $rem-baseline, $separator);
        }

        @else if type-of($value)=="number"and unit($value)=="px"and $to=="rem" {
            $result: append($result, math.div($value, $rem-baseline) * 1rem, $separator);
        }

        @else if type-of($value)=="list" {
            $value-separator: rem-separator($value);
            $value: rem-convert($to, $value...);
            $value: rem-separator($value, $value-separator);
            $result: append($result, $value, $separator);
        }

        @else {
            $result: append($result, $value, $separator);
        }
    }

    @return if(length($result)==1, nth($result, 1), $result);
}

@function rem($values...) {
    @if $rem-px-only {
        @return rem-convert(px, $values...);
    }

    @else {
        @return rem-convert(rem, $values...);
    }
}

@mixin rem($properties, $values...) {
    @if (type-of($properties)=="map") {
        @each $property in map-keys($properties) {
            @include rem($property, map-get($properties, $property));
        }
    }

    @else {
        @each $property in $properties {
            @if $rem-px-only {
                #{$property}: rem-convert(px, $values...);
            }

            @if not $rem-px-only {
                #{$property}: rem-convert(rem, $values...);
            }
        }
    }
}
